package com.example.wallisyn;

import android.app.Application;
import android.content.Context;
import android.graphics.Typeface;
import android.util.Log;

import com.example.wallisyn.mybean.MyData;
import com.example.wallisyn.tool.ComUtils;
import com.example.wallisyn.tool.JsonData;
import com.example.wallisyn.tool.ObectBoxManager;
import com.thinkup.core.api.TUSDK;
import com.up.uploadlibrary.UpLoadManager;

import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import kotlin.Unit;
import kotlin.jvm.functions.Function2;

public class MyApp extends Application {
    public static Context mAppContext;

    public static String TAG = "-------MyApp---------";
    public static Typeface defaultFont;


    private String animasName = "Animals.json";
    private String exName = "Experimental.json";
    private String filmName = "Film.json";
    private String natureName = "Nature.json";
    private String pattName = "Patterns.json";
    private String streetName = "Street.json";
    private String travelName = "Travel.json";
    private String wallpaperName = "Featured.json";
    private ExecutorService executor;
    private static List<String> CategoryNames = new ArrayList<>();
    private int i = 0;

    @Override
    public void onCreate() {
        super.onCreate();
        mAppContext = this;
        defaultFont = Typeface.createFromAsset(getAssets(), "custfont.ttf");

        ObectBoxManager.init(this);
        executor = Executors.newFixedThreadPool(8);
        String[] names = {wallpaperName, animasName, exName, filmName, natureName, pattName, streetName, travelName};

        try {
            for (String name : names) {
                InputStream open = getAssets().open(name);
                String covertStr = ComUtils.getCovertStr(open);
                if (!covertStr.isEmpty()) {
                    String realName = name.substring(0, name.indexOf("."));
                    CategoryNames.add(realName);
                    executor.execute(new Runnable() {
                        @Override
                        public void run() {
                            i++;
                            Log.d(MyApp.TAG, "------------111");
                            List<MyData> data = JsonData.INSTANCE.getData(covertStr, realName);
                            Collections.shuffle(data);
                            for (MyData data1:data){
                                ObectBoxManager.addData(data1);
                            }

//                            if (i == 8) {
//                                executor.shutdown();
//                                Log.d(MyWallpaper.TAG, "------------data complete");
//                            }

                        }
                    });
                }
            }


        } catch (IOException e) {
            throw new RuntimeException(e);
        }

        TUSDK.init(this,"h693100e76a58b","aa1b0a657e26663f1efaa3ecc5604ec30");
        UpLoadManager.INSTANCE.init(this, "wallisyn_up_load", (s, s2) -> null);
    }

    public static List<String> getCategoryNames() {
        return CategoryNames;
    }

}
